#!/bin/sh
#
#   $Id: ppconfig,v 1.2 2003/06/05 10:54:33 serg Exp $
#
TMPDIR=${TMPDIR:-/tmp}
export TMPDIR

MODE=pppd
MODE=wvdial
pphome=${DESTDIR}/etc/ppp
wvdialconf=${DESTDIR}/etc/wvdial.conf
RESOLV=/etc/resolv.conf		# Where resolv.conf file is.
settings=$TMPDIR/`basename $0`.setings

tempmsg=`mktemp $TMPDIR/tmpmsg.XXXXXX`
tempreply=`mktemp $TMPDIR/tmpreply.XXXXXX`

trap "rm -f $tempmsg $tempreply; exit" EXIT 1 2 3 15 

which dialog >/dev/null 2>&1
if [ $? != 0 ]; then
  echo "dialog not found, exiting"
  exit 2
fi

if [ ! -d $TMPDIR ]; then
 mkdir -p $TMPDIR
 chmod 1777 $TMPDIR
fi

# load defaults from $settings
test -r $settings && . $settings

# protect files
umask 077

if [ "$MODE" = "pppd" ]; then
  LOGINMODE=PAP
  MODEM=ttyS0

  cat << EOF > $tempmsg
      .

      COM2.
EOF
  dialog --title " " --menu "`cat $tempmsg`" \
       11 71 2 \
       "COM2" "   COM2 (ttyS1)" \
       "COM1" "   COM1 (ttyS0)" \
       2>$tempreply

  test $? = 1 -o $? = 255 && exit 2
  if [ `cat $tempreply` = "COM1" ]; then
    MODEM=ttyS0
  else
    MODEM=ttyS1
  fi
fi  # $MODE = pppd

cat << EOF > $tempmsg
\n\n   .
EOF
dialog --title "  PPP  " \
        --inputbox "`cat $tempmsg`" \
        10 50 "$PHONE" 2> $tempreply
test $? = 1 -o $? = 255 && exit 2
PHONE="`cat $tempreply`"
echo 'PHONE="'"$PHONE"'"' >> $settings

cat << EOF > $tempmsg

    ,  PAP -- 
   .

 "Script",   
   .
  
EOF
  dialog --title "    " --menu "`cat $tempmsg`" \
       15 52 2 \
       "PAP" "Password Authentication Protocol" \
       "Script" " " \
       2>$tempreply
  test $? = 1 -o $? = 255 && exit 2

  if [ `cat $tempreply` = "PAP" ]; then
    LOGINMODE=PAP
  else
    LOGINMODE=SCRIPT
  fi

cat << EOF > $tempmsg
\n\n      Internet.
EOF
dialog --title "  PPP  " \
        --inputbox "`cat $tempmsg`" \
        10 50 "$PPPLOGIN" 2> $tempreply
test $? = 1 -o $? = 255 && exit 2

PPPLOGIN="`cat $tempreply`"
echo 'PPPLOGIN="'"$PPPLOGIN"'"' >> $settings

cat << EOF > $tempmsg
\n[i]     
\n\n      Internet.
EOF
dialog --title "  PPP  " \
        --inputbox "`cat $tempmsg`" \
        12 50 "$PPPPASSWORD" 2> $tempreply
test $? = 1 -o $? = 255 && exit 2

PPPPASSWORD="`cat $tempreply`"
echo 'PPPPASSWORD="'"$PPPPASSWORD"'"' >> $settings

test -d $pphome || mkdir -p $pphome
cat << EOF > $pphome/options
# General configuration options for PPPD:
lock
defaultroute
noipdefault
persist
usepeerdns
debug 4
EOF

cat <<EOF >$pphome/ip-up
#!/bin/sh -x
export DISPLAY=:0.0
/usr/X11R6/bin/xterm -e dialog --msgbox "\n
             " 8 50 &
test -f /etc/ppp/resolv.conf && ln -sf /etc/ppp/resolv.conf $RESOLV
EOF
cat <<EOF >$pphome/ip-down
#!/bin/sh
export DISPLAY=:0.0
/usr/X11R6/bin/xterm -e dialog --msgbox "\n
              " 8 50 &
#test -f $RESOLV && rm -f $RESOLV
EOF
chmod 755 $pphome/ip-up
chmod 755 $pphome/ip-down

##it will be done by /etc/ppp/ip-up script
#touch $pphome/resolv.conf
#ln -sf $pphome/resolv.conf $RESOLV
#rm -f $pphome/resolv.conf


if [ "$MODE" = "pppd" ]; then
  cat << EOF >> $pphome/options
modem
/dev/$MODEM
57600
crtscts
connect 'chat -v -f $pphome/chatscript'
# Uncomment the line below for more verbose error reporting:
#debug
passive
asyncmap 0
EOF
  cat <<EOF > $pphome/chatscript
TIMEOUT 10
ABORT ERROR
ABORT BUSY
ABORT "NO CARRIER"
ABORT "NO ANSWER"
ABORT "NO DIALTONE"
"" AT
OK ATZ
OK ATE1M1L2
OK ATDP$PHONE
TIMEOUT 75
EOF

  if [ "$LOGINMODE" = PAP ]; then
    echo "CONNECT" >> $pphome/chatscript
    echo "user "'"'"$PPPLOGIN"'"' >> $pphome/options
    echo '"'"$PPPLOGIN"'"   *   "'"$PPPPASSWORD"'"' > $pphome/pap-secrets
  else
    echo 'ogin: "'"$PPPLOGIN"'"' >>$pphome/chatscript
    echo 'word: "'"$PPPPASSWORD"'"' >>$pphome/chatscript
  fi
else # $MODE != pppd
  cat <<EOF > ${wvdialconf}
[Dialer Defaults]
Init3 = atl1m1
Dial Command = atdp
Phone = $PHONE
Username = $PPPLOGIN
Password = $PPPPASSWORD
EOF

  cat <<EOF > $tempmsg

      
  .

, :
1.  ,
2.   ,
3.      .

[i]    :  
  , 
 ,    
,   .
EOF
  dialog --title '   ' \
          --msgbox "`cat $tempmsg`" 18 55

  test $? -ne 0 && exit 2
  clear
  wvdialconf ${wvdialconf}
  STATUS=$?

  if [ $STATUS != 0 ]; then
dialog --msgbox \
"\n
              " 8 50
    clear
    exit 2
  fi
  
  if [ -f ${wvdialconf} ]; then
    chmod 600 ${wvdialconf}
  fi
dialog --msgbox \
"\n
             " 8 50
  # force PAP authorization
  echo '"'"${PPPLOGIN}"'"   *   "'"${PPPPASSWORD}"'"' > $pphome/pap-secrets
  echo "user ${PPPLOGIN}" >> $pphome/peers/wvdial
  if [ "$LOGINMODE" = PAP ]; then
    echo "Stupid Mode = 1" >> ${wvdialconf}
  else
    echo "Stupid Mode = 0" >> ${wvdialconf}
  fi
fi # $MODE != pppd

dialog  --yesno \
"\n
        PPP  ?
\n" 7 50
if [ $? = 0 ]; then
  clear
  if [ x"$MODE" = x"pppd" ]; then
    pppd
  else
    #
    #   wvdial     xterm',   , 
    #       xterm -e wvdial &
    #     ()       ppconfig
    #    SIGCHLD(?)   .
    #
    #        (`&'),    xterm',
    #         
    #   xterm,      .
    #
    #    wvdial     xterm'  ,  
    #           
    #      xterm' `PPP '.
    #       title bar.
    #
    if [ x"$DISPLAY" != x ]; then
      #   title bar  ,     xterm'
      echo -en "\033]2;PPP \007"
    fi
    exec wvdial
  fi
fi
